package MT::Plugin::SKR::AtOncePluginSwitcher;

use strict;
use MT 4;

use vars qw( $MYNAME $VERSION );
$MYNAME = 'AtOncePluginSwitcher';
$VERSION = '0.01';

use base qw( MT::Plugin );
my $plugin = __PACKAGE__->new({
    name => $MYNAME,
    id => lc $MYNAME,
    key => lc $MYNAME,
    version => $VERSION,
    author_name => 'SKYARC System Co.,Ltd.',
    author_link => 'http://www.skyarc.co.jp/',
    doc_link => 'http://www.skyarc.co.jp/engineerblog/entry/movabletypemovabletypeatoncepluginswitcher.html',
    description => <<PERLHEREDOC,
<__trans phrase="Enable you to switch on/off some plugins at once.">
PERLHEREDOC
    system_config_template => \&config_tmpl,
});
MT->add_plugin ($plugin);

sub instance { $plugin; }



###
sub config_tmpl {
    my ($plugin, $param, $scope) = @_;

    my @plugins;
    foreach (keys %MT::Plugins) {
        my $profile = $MT::Plugins{$_};
        if (my $plugin = $profile->{object}) {
            push @plugins, {
                sig => $_,
                name => $plugin && $plugin->name || $_,
                enabled => 1,
            } if $plugin->isa('MT::Plugin');
        }
        else {
            push @plugins, {
                sig => $_,
                name => $_,
                enabled => 0,
            };
        }
    }
    @plugins = sort { $a->{name} cmp $b->{name} } @plugins;
    $param->{PLUGINS} = \@plugins;

    <<HTMLHEREDOC;
<mtapp:setting
    id="plugins"
    label="<__trans phrase="Plugins">">
<ul><TMPL_LOOP NAME=PLUGINS>
<li><input type="checkbox" name="<TMPL_VAR NAME=SIG ESCAPE=HTML>"<TMPL_IF NAME=ENABLED> checked="checked"</TMPL_IF> /><TMPL_VAR NAME=NAME ESCAPE=HTML>
</TMPL_LOOP></ul>
</mtapp:setting>
HTMLHEREDOC
}

###
sub save_config {
    my ($plugin, $param, $scope) = @_;

    my $cfg = MT->app->config;
    foreach (keys %MT::Plugins) {
        $cfg->PluginSwitch ($_. '='. (defined $param->{$_} ? 1 : 0), 1);
    }
}

1;